<?php
/*
--------------------------------------------------------------------------------
PhpDig 1.4.x
This program is provided under the GNU/GPL license.
See LICENSE file for more informations
All contributors are listed in the CREDITS file provided with this package

PhpDig Website : http://phpdig.toiletoine.net/
Contact email : phpdig@toiletoine.net
Author and main maintainer : Antoine Bajolet (fr) bajolet@toiletoine.net
--------------------------------------------------------------------------------
*/

//-------------UTILS FUNCTIONS

//=================================================
// extract _POST or _GET variables from a list varname => vartype
// Useful for error_reporting E_ALL too, init variables
// usage in script : extract(phpdigHttpVars(array('foobar'=>'string')));
function phpdigHttpVars($varray=array()) {
$parse_orders = array('_POST','_GET','HTTP_POST_VARS','HTTP_GET_VARS');
$httpvars = array();
// extract the right array
if (is_array($varray)) {
    foreach($parse_orders as $globname) {
          global $$globname;
          if (!count($httpvars) && isset($$globname) && is_array($$globname)) {
              $httpvars = $$globname;
          }
    }
    // extract or create requested vars
    foreach($varray as $varname => $vartype) {
       if (in_array($vartype,array('integer','bool','double','float','string','array')) ) {
         if (!isset($httpvars[$varname])) {
            $httpvars[$varname] = false;
         }
         settype($httpvars[$varname],$vartype);
       }
    }
return $httpvars;
}
}

//-------------STRING FUNCTIONS

//=================================================
//returns a localized string
function phpdigMsg($string='') {
global $phpdig_mess;
if (isset($phpdig_mess[$string])) {
    return nl2br($phpdig_mess[$string]);
}
else {
    return ucfirst($string);
}
}

//print a localized string
function phpdigPrnMsg($string='')
{
global $phpdig_mess;
if (isset($phpdig_mess[$string])) {
    print nl2br($phpdig_mess[$string]);
}
else {
    print ucfirst($string);
}
}

//=================================================
//load the common words in an array
function phpdigComWords($file='')
{
$lines = @file($file);
if (is_array($lines))
    {
    while (list($id,$word) = each($lines))
           $common[trim($word)] = 1;
    }
else
    $common['aaaa'] = 1;
return $common;
}

//=================================================
//highlight a string part
function phpdigHighlight($ereg="",$string="")
{
if ($ereg)
    return @eregi_replace('('.$ereg.')',"<SPAN class='phpdigHighlight'>\\1</SPAN>",$string);
else
    return $result;
}

//=================================================
//replace all characters with an accent
function phpdigStripAccents($chaine)
{
return( strtr( $chaine,
"",
"AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn" ) );
}

//==========================================
//Create a ereg for highlighting
function phpdigPregQuotes($chaine)
{
$chaine = preg_quote(strtolower(phpdigStripAccents($chaine)));
$chaine = str_replace('e','[e]',$chaine);
$chaine = str_replace('i','[i]',$chaine);
$chaine = str_replace('u','[u]',$chaine);
$chaine = str_replace('o','[o]',$chaine);
$chaine = str_replace('a','[a]',$chaine);
$chaine = str_replace('c','[c]',$chaine);
$chaine = str_replace('n','[n]',$chaine);
return  str_replace('y','[y]',$chaine);
}

//=================================================
//epure a string from all non alnum words (words can contain &__& character)
function phpdigEpureText($text,$min_word_length=2)
{
$text = phpdigStripAccents(strtolower ($text));
//no-latin upper to lowercase - now islandic
$text = strtr( $text,
'',
'');
$text = ereg_replace('[[:blank:]][0-9]+[[:blank:]]',' ',ereg_replace('[^[:alnum:]._&%/-]+',' ',$text));
$text = ereg_replace('[[:blank:]][^ ]{1,'.$min_word_length.'}[[:blank:]]',' ',' '.$text.' ');
$text = ereg_replace('\.+[[:blank:]]|\.+$',' ',$text);
return trim(ereg_replace("[[:blank:]]+"," ",$text));
}
?>